/**
 * @license
 * Copyright 2022 Google LLC
 * SPDX-License-Identifier: Apache-2.0
 */
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _AsyncCache_cache;
/**
 * A cache for values that are asynchronously computed that ensures that we
 * will compute the value for each key at most once.
 */
export class AsyncCache {
    constructor() {
        _AsyncCache_cache.set(this, new Map());
    }
    async getOrCompute(key, compute) {
        let result = __classPrivateFieldGet(this, _AsyncCache_cache, "f").get(key);
        if (result === undefined) {
            result = compute();
            __classPrivateFieldGet(this, _AsyncCache_cache, "f").set(key, result);
        }
        return result;
    }
    get values() {
        return __classPrivateFieldGet(this, _AsyncCache_cache, "f").values();
    }
}
_AsyncCache_cache = new WeakMap();
//# sourceMappingURL=async-cache.js.map